"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.























































readAllVirtualHosts = readAllVirtualHosts;exports.










readVirtualHostById = readVirtualHostById;exports.







readDefaultVirtualHost = readDefaultVirtualHost;exports.







readProxyUrl = readProxyUrl;exports.








readManifestUrl = readManifestUrl;var _logger = require("../logger");var _logger2 = _interopRequireDefault(_logger);var _utils = require("../utils");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function findDefault(array) {if (array) {for (var i = 0; i < array.length; ++i) {if (array[i].isDefault) {return array[i];}}}_logger2.default.error("Unable to parse API Management OData response; could not find default object.");throw new Error("Unable to parse API Management OData response.");}function findById(array, id) {if (array) {for (var i = 0; i < array.length; ++i) {if (array[i].id === id) {return array[i];}}}_logger2.default.error("Unable to parse API Management OData response; could not find object with id: " + id + ".");throw new Error("Unable to parse API Management OData response.");}function nonStartingSlash(uri) {return uri.indexOf("/") === 0 ? uri.substr(1) : uri;}function vhostToUrl(vhost) {var result = (vhost.isSSL ? "https://" : "http://") + vhost.virtual_host;if (vhost.virtual_port) {result += ":" + vhost.virtual_port;}result += "/";if (vhost.projectPath) {result += nonStartingSlash(vhost.projectPath) + "/";}return result;}function parseVirtualHost(vhost) {return { url: vhostToUrl(vhost), ssl: vhost.isSSL || false, id: vhost.id, name: vhost.name, default: vhost.isDefault, host: vhost.virtual_host, port: vhost.virtual_port || null, projectPath: vhost.projectPath || null };}function readAllVirtualHosts(client) {return client.readVirtualHosts().then(function (info) {_logger2.default.debug("Got vhost information and retrieved all vhosts.");var result = [];var _iteratorNormalCompletion = true;var _didIteratorError = false;var _iteratorError = undefined;try {for (var _iterator = info[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {var vhost = _step.value;result.push(parseVirtualHost(vhost));}} catch (err) {_didIteratorError = true;_iteratorError = err;} finally {try {if (!_iteratorNormalCompletion && _iterator.return) {_iterator.return();}} finally {if (_didIteratorError) {throw _iteratorError;}}}return result;});}function readVirtualHostById(client, id) {return client.readVirtualHosts().then(function (info) {var vhost = findById(info, id);_logger2.default.debug("Got vhost information and retrieved vhost with id: " + id + ".");return parseVirtualHost(vhost);});}function readDefaultVirtualHost(client, id) {return client.readVirtualHosts().then(function (info) {var vhost = findDefault(info, id);_logger2.default.debug("Got vhost information for default vhost.");return parseVirtualHost(vhost);});}function readProxyUrl(client, name) {return client.readProxyInfo(name).then(function (info) {_logger2.default.debug("Got information for proxy:" + name + ".");var proxy = findDefault(info.proxyEndPoints.results);var host = findDefault(proxy.virtualhosts.results);return vhostToUrl(host) + nonStartingSlash(proxy.base_path);});}function readManifestUrl(client, path) {
    return (0, _utils.parseManifest)(path).then(function (manifest) {return readProxyUrl(client, manifest.proxy.name);});
}